#ifndef FREE_TREE_HEADER
#define FREE_TREE_HEADER

#include "../support/nodes.h"

void FreeTree(Program * program);

void FreeExpression(Expression * expression);
void FreeDomain(Domain * domain);
void FreeBoolean(Boolean * boolean);
void FreeIf(If * if_st);
void FreeDeclareVariable(Variable * variable);
void FreeAssignVariable(AssignVariable * variable);
void FreePrint(Print * print_st);
void FreeWhile(While * while_st);
void FreeStatement(Statement * statement);
void FreeBlock(Block * block);

#define DEFAULT_TABLE_SIZE 500

typedef struct MallocTable {
    void ** elements;
    int used;
    int size;
} MallocTable;

void InitializeMallocTable();
void AddMalloc(void * pointer);
void FreeMallocTable();

#endif